/*
 * Criao de uma nova thread, com envio de valor de retorno. 
 * Suponha que a nova thread deva informar um valor inteiro para
 * a thread main.
 *
 * Nesta abordagem, a nova thread retorna um apontador para um inteiro
 * que  uma varivel global.
 */
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>

int retorno; /* Varivel global */

void* f_thread(void *v) {
  retorno = 256;
  printf("Nova Thread ir retornar um apontador para um inteiro que contm 256.\n");
  return (void*) &retorno;
}

int main() {
  pthread_t thr;
  int* retorno_thr;

  pthread_create(&thr, NULL, f_thread, NULL);
  
  pthread_join(thr, (void**) &retorno_thr);

  retorno = 57; /* Acesso  varivel global por outra
		   thread pode invalidar o processo */
  
  printf("Valor de retorno (apontador): %p\n", retorno_thr);
  printf("Valor de retorno (contedo): %d\n", *retorno_thr);


  return 0;
}
